
--*****************************************************************
--**                    Are ya winning, son?                     **
--*****************************************************************

local Shared = MandelaBowAndArrow.Shared;
local Client = MandelaBowAndArrow.Client;

function Client.isMandelaBow(itemFullType, number)
	if Shared.Bows[itemFullType] ~= nil
	then return true;
	else return false; end
end

Client.logo = getTexture("media/ui/Traits/trait_MBAOarcher.png");
Client.arrowBlankTexture = getTexture("media/textures/Item_MBA_ModularArrow_Blank.png");
Client.arrowBlankTextureName = Client.arrowBlankTexture:getName();

Client.Sounds = {
	HitTile = "ChopTree",
	HitHead = "ChopTree",
	HitBody = "ChopTree"
}

--*******************************************************************************************************
--**                    The item list things have been moved from Client to Shared                     **
--*******************************************************************************************************

-- Compatibility thing below, in case a mod for this mod
--[[Client.Bows = Shared.Bows;
Client.AmmoTypes = Shared.AmmoTypes;
Client.NoMandelaCustomTooltip = Shared.NoMandelaCustomTooltip;
Client.AttachmentConversion = Shared.AttachmentConversion;
Client.ArrowPartData = Shared.ArrowPartData;
Client.AttachmentWeight = Shared.AttachmentWeight;
Client.AttachmentModels = Shared.AttachmentModels;
Client.WeaponWithAttachmentList = Shared.WeaponWithAttachmentList;]]--
-- On further thought, better left as red error causing

------------------------------------------------------------------
Client.QuiverTypes = Client.QuiverTypes or {};
if not Client.QuiverTypes["QuiverB"] then
	Client.QuiverTypes["QuiverB"] = {
		Type = "InventoryContainer",
		CheckIfHas = function (character)
			for i=0, character:getWornItems():size()-1 do
				local item = character:getWornItems():getItemByIndex(i);
				if item:getType() == "QuiverB" then return item:getInventory() end
			end
			return nil
		end,
		ChangeReloadSpeed = function (character, baseLoadSpeed)
			return baseLoadSpeed + 0.3;
		end
	};
end

function Client.CheckForQuivers(character, quiverTable)
	for i,v in pairs (Client.QuiverTypes) do
		if v.CheckIfHas(character) then
			table.insert(quiverTable, 1, v.CheckIfHas(character))
		end
	end
end
-- For adding compatibility with a quiver from a mod that adds a quiver.
------------------------------------------------------------------



--This is for a custom recipe-like system.
Client.Recipes = {}

Client.Recipes.AddArrowHead = {
	name = getText("IGUI_MBA_recipe_AddArrowHead"),
	workSound = nil,
	animNode = nil,
	stopOnWalk = true,
	stopOnRun = true,
	prop1 = "arrow",
	skill = {Woodwork = 2},
	time = 30,
	done = function(self)
		local arrowHead = table.remove(self.arrowParts, 1);
		local arrow = table.remove(self.arrows, 1);
		local factoryItem = InventoryItemFactory.CreateItem(Shared.AttachmentConversion[arrowHead:getFullType()]);
		arrow:attachWeaponPart(factoryItem);
		self.container:Remove(arrowHead);
		Shared.SetArrowName(arrow);
		self.character:resetEquippedHandsModels();
	end
}

Client.Recipes.AddFletchings = {
	name = getText("IGUI_MBA_recipe_AddFletchings"),
	workSound = nil,
	animNode = nil,
	stopOnWalk = true,
	stopOnRun = true,
	prop1 = "arrow",
	time = 30,
	done = function(self)
		local fletchings = table.remove(self.arrowParts, 1);
		local arrow = table.remove(self.arrows, 1);
		local factoryItem = InventoryItemFactory.CreateItem(Shared.AttachmentConversion[fletchings:getFullType()]);
		arrow:attachWeaponPart(factoryItem);
		self.container:Remove(fletchings);
		Shared.SetArrowName(arrow);
		self.character:resetEquippedHandsModels();
	end
}

Client.Recipes.RemoveArrowHead = {
	name = getText("IGUI_MBA_recipe_RemoveArrowHead"),
	workSound = nil,
	animNode = nil,
	stopOnWalk = true,
	stopOnRun = true,
	prop1 = "arrow",
	time = 30,
	done = function(self)
		local arrow = table.remove(self.arrows, 1);
		local arrowHead = arrow:getCanon()
		arrow:detachWeaponPart(arrowHead);
		local factoryItem = InventoryItemFactory.CreateItem(Shared.AttachmentConversion[arrowHead:getFullType()]);
		self.character:getInventory():AddItem(factoryItem);
		Shared.SetArrowName(arrow);
		self.character:resetEquippedHandsModels();
	end
}

Client.Recipes.RemoveFletchings = {
	name = getText("IGUI_MBA_recipe_RemoveFletchings"),
	workSound = nil,
	animNode = nil,
	stopOnWalk = true,
	stopOnRun = true,
	prop1 = "arrow",
	time = 30,
	done = function(self)
		local arrow = table.remove(self.arrows, 1);
		local arrowFletching = arrow:getRecoilpad()
		arrow:detachWeaponPart(arrowFletching);
		local factoryItem = InventoryItemFactory.CreateItem(Shared.AttachmentConversion[arrowFletching:getFullType()]);
		self.character:getInventory():AddItem(factoryItem);
		Shared.SetArrowName(arrow);
		self.character:resetEquippedHandsModels();
	end
}

Client.Recipes.SnapIntoTwigs = {
	name = getText("IGUI_MBA_snap_into_twigs"),
	workSound = nil,
	animNode = nil,
	stopOnWalk = false,
	stopOnRun = true,
	prop1 = "arrow",
	time = 30,
	done = function(self)
		local arrow = table.remove(self.arrows, 1);
		local arrowHead = arrow:getCanon();
		if arrowHead then
			arrow:detachWeaponPart(arrowHead);
			local factoryItem = InventoryItemFactory.CreateItem(Shared.AttachmentConversion[arrowHead:getFullType()]);
			self.character:getInventory():AddItem(factoryItem);
		end
		
		local arrowFletching = arrow:getRecoilpad();
		if arrowFletching then
			arrow:detachWeaponPart(arrowFletching);
			local factoryItem = InventoryItemFactory.CreateItem(Shared.AttachmentConversion[arrowFletching:getFullType()]);
			self.character:getInventory():AddItem(factoryItem);
		end
		
		self.character:getInventory():Remove(arrow);
		self.character:resetEquippedHandsModels();
		local factoryItem = InventoryItemFactory.CreateItem("Base.Twigs");
		self.character:getInventory():AddItem(factoryItem);
	end
}