--[[local group = AttachedLocations.getGroup("Human")
for i=0, 360, 10 do
	group:getOrCreateLocation("MBA_forehead_"..tostring(i).."_0"):setAttachmentName("MBA_forehead_"..tostring(i).."_0")
end
]]--
MandelaBowAndArrow = MandelaBowAndArrow or {};
MandelaBowAndArrow.Shared = MandelaBowAndArrow.Shared or {};
MandelaBowAndArrow.Client = MandelaBowAndArrow.Client or {};
MandelaBowAndArrow.Server = MandelaBowAndArrow.Server or {};
local Shared = MandelaBowAndArrow.Shared;
local Client = MandelaBowAndArrow.Client;
Shared.nan = tostring(0/0);
Shared._nan = tostring(-(0/0));

--This mod creates a table inside the thing's modData, and stores its stuff in that.
function Shared.getModData(thing)
	if thing:getModData().MandelaBowAndArrow == nil then thing:getModData().MandelaBowAndArrow = {} end
	return thing:getModData().MandelaBowAndArrow
end

--Older versions of this mod didn't do this, so this function converts old mod type mod data into new type
function Shared.modDataCompatibility(thing)
	local oldModData = thing:getModData();
	local newModData = Shared.getModData(thing);
	if oldModData.MBAOarrowCondition ~= nil then
		newModData.arrowCondition = oldModData.MBAOarrowCondition;
		oldModData.MBAOarrowCondition = nil;
	end
	if oldModData.MBAOarrowFullType ~= nil then
		newModData.arrowFullType = oldModData.MBAOarrowFullType;
		oldModData.MBAOarrowFullType = nil;
	end
	if oldModData.MBAOstaveProgress ~= nil then
		newModData.progress = oldModData.MBAOarrowFullType;
		oldModData.MBAOstaveProgress = nil;
	end
	if oldModData.MBAOcondition ~= nil then
		newModData.condition = oldModData.MBAOcondition;
		oldModData.MBAOcondition = nil;
	end
	if newModData.arrowFullType ~= nil then
		newModData.arrowData = {condition = newModData.condition, fullType = newModData.arrowFullType, modData = {}};
		newModData.arrowFullType = nil;
	end
end

--Arrow shaft names
Shared.ArrowShaftNames = {
	["MandelaBowAndArrow.MandelaAttachmentShaftWood"] = getText("IGUI_MBA_arrow_shaft_of_wood");
}

--This function sets the name of an arrow
function Shared.SetArrowName(arrow)
	if not arrow:getStock() then
		print("Bow and Arrow mod: SetArrowName trying to set name of arrow with no shaft attachment");
		return;
	end
	local name;
	--local weight = Shared.AttachmentWeight[arrow:getStock():getFullType()] or 0;
	if arrow:getRecoilpad() then
		if arrow:getCanon() then
			name = getText("IGUI_MBA_arrow");
		else
			name = getText("IGUI_MBA_arrow_headless");
		end
		if arrow:getRecoilpad():getFullType() == "MandelaBowAndArrow.MandelaAttachmentFletchingsDucttapeFluFlu" then
			name = name .. getText("IGUI_MBA_fluflu");
		end
		--weight = weight + (Shared.AttachmentWeight[arrow:getRecoilpad():getFullType()] or 0);
	else
		if arrow:getCanon() then
			name = getText("IGUI_MBA_arrow_unfletched");
		else
			name = Shared.ArrowShaftNames[arrow:getStock():getFullType()];
		end
	end
	if arrow:getCanon() then
		--weight = weight + (Shared.AttachmentWeight[arrow:getCanon():getFullType()] or 0);
	end
	--arrow:setActualWeight(weight);
	--arrow:setCustomWeight(true);
	arrow:setName(name);
end


------------------------------- Items -- Moved here from MBA_Items in Client, so MBA_Items isn't a good name for it any more

Shared.Bows = Shared.Bows or {};

Shared.Bows["Base.MandelaBow"] = {
	speed = 0.25,
	aimingAngle = 30,
	aimingDistance = 17,
	weaponOffset = 0.9,
	deviationMultiplier = 1.5,
	--gravity = 0.003, --does nothing apparently
	model = "MandelaBowAndArrow.MandelaBow",
	soundVolume = 1,
	soundRadius = 4};

Shared.Bows["MandelaBowAndArrow.CompoundBowScorpion"] = {
	speed = 0.3,
	aimingAngle = 30,
	aimingDistance = 17,
	weaponOffset = 0.9,
	deviationMultiplier = 1.3,
	model = "MandelaBowAndArrow.CompoundBowScorpion",
	soundVolume = 1,
	soundRadius = 4};

Shared.Bows["MandelaBowAndArrow.MandelaBowWoodLong"] = {
	speed = 0.25,
	aimingAngle = 30,
	aimingDistance = 17,
	weaponOffset = 0.9,
	deviationMultiplier = 1.5,
	model = "MandelaBowAndArrow.MandelaBow",
	soundVolume = 1,
	soundRadius = 4};

--Data for older type arrows like before modular arrows were added. You can still add non-modular arrows.
Shared.AmmoTypes = Shared.AmmoTypes or {};
Shared.AmmoTypes["Base.MandelaArrowWoodDucttapeIronTaped"] = {priority = 1, quiver = true, model = "MandelaBowAndArrow.MandelaArrowWoodDucttapeIronTaped"};
Shared.AmmoTypes["Base.MandelaArrowWoodDucttapeIron"] = {priority = 3, quiver = true, model = "MandelaBowAndArrow.MandelaArrowWoodDucttapeIron"};
Shared.AmmoTypes["MandelaBowAndArrow.MandelaArrowBlank"] = {quiver = true};

Shared.NoMandelaCustomTooltip = Shared.NoMandelaCustomTooltip or {};

--For example, MandelaBowAndArrow.MandelaArrowHeadIron2 is an item seen in the inventory, whereas MandelaBowAndArrow.MandelaAttachmentHeadIron a "WeaponPart" sort of item that adds a model to the arrow when attached.
Shared.AttachmentConversion = {
	["Base.MandelaArrowHeadIron"] = "MandelaBowAndArrow.MandelaAttachmentHeadIron",
	["MandelaBowAndArrow.MandelaArrowHeadIron2"] = "MandelaBowAndArrow.MandelaAttachmentHeadIron",
	["MandelaBowAndArrow.MandelaAttachmentHeadIron"] = "MandelaBowAndArrow.MandelaArrowHeadIron2",
	
	["MandelaBowAndArrow.MandelaArrowHeadFlint"] = "MandelaBowAndArrow.MandelaAttachmentHeadFlint",
	["MandelaBowAndArrow.MandelaAttachmentHeadFlint"] = "MandelaBowAndArrow.MandelaArrowHeadFlint",
	
	["Base.MandelaFletchings"] = "MandelaBowAndArrow.MandelaAttachmentFletchingsDucttape",
	["MandelaBowAndArrow.MandelaFletchingsDuctTape"] = "MandelaBowAndArrow.MandelaAttachmentFletchingsDucttape",
	["MandelaBowAndArrow.MandelaAttachmentFletchingsDucttape"] = "MandelaBowAndArrow.MandelaFletchingsDuctTape",
	
	["MandelaBowAndArrow.MandelaFletchingsDuctTapeFluFlu"] = "MandelaBowAndArrow.MandelaAttachmentFletchingsDucttapeFluFlu",
	["MandelaBowAndArrow.MandelaAttachmentFletchingsDucttapeFluFlu"] = "MandelaBowAndArrow.MandelaFletchingsDuctTapeFluFlu",
	
	["MandelaBowAndArrow.MandelaFletchingsFeathers"] = "MandelaBowAndArrow.MandelaAttachmentFletchingsFeather",
	["MandelaBowAndArrow.MandelaAttachmentFletchingsFeather"] = "MandelaBowAndArrow.MandelaFletchingsFeathers"
}
--[[
Shared.AttachmentIcons = {
	["MandelaBowAndArrow.MandelaAttachmentShaftWood"] = getTexture("media/textures/Item_MBA_ModularArrow_ShaftWood.png"),
	["MandelaBowAndArrow.MandelaAttachmentHeadIron"] = getTexture("media/textures/Item_MBA_ModularArrow_HeadIron1.png"),
	["MandelaBowAndArrow.MandelaAttachmentHeadIronTaped"] = getTexture("media/textures/Item_MBA_ModularArrow_HeadIronTaped.png"),
	["MandelaBowAndArrow.MandelaAttachmentFletchingsDucttape"] = getTexture("media/textures/Item_MBA_ModularArrow_FletchingsDuctTape.png"),
}]]--

Shared.ArrowPartData = {
	["Base.MandelaArrowHeadIron"] = {sort = "Head"},
	["MandelaBowAndArrow.MandelaArrowHeadIron2"] = {sort = "Head"},
	["MandelaBowAndArrow.MandelaArrowHeadFlint"] = {sort = "Head"},
	["Base.MandelaFletchings"] = {sort = "Fletchings"},
	["MandelaBowAndArrow.MandelaFletchingsDuctTape"] = {sort = "Fletchings"},
	["MandelaBowAndArrow.MandelaFletchingsDuctTapeFluFlu"] = {sort = "Fletchings", fluflu = true},
	["MandelaBowAndArrow.MandelaFletchingsFeathers"] = {sort = "Fletchings"}
}

--Arrow parts should increase the arrow's weight by amount specific to the parts.
Shared.AttachmentWeight = {
	["MandelaBowAndArrow.MandelaAttachmentShaftWood"] = 0.03,
	["MandelaBowAndArrow.MandelaAttachmentHeadIron"] = 0.07,
	["MandelaBowAndArrow.MandelaAttachmentHeadIronTaped"] = 0.07,
	["MandelaBowAndArrow.MandelaAttachmentHeadFlint"] = 0.07,
	["MandelaBowAndArrow.MandelaAttachmentFletchingsDucttape"] = 0.01,
	["MandelaBowAndArrow.MandelaAttachmentFletchingsDucttapeFluFlu"] = 0.02,
	["MandelaBowAndArrow.MandelaAttachmentFletchingsFeather"] = 0.01
}

Shared.AttachmentModels = {
	["MandelaBowAndArrow.MandelaAttachmentShaftWood"] = "MandelaBowAndArrow.MandelaArrowShaftWood",
	["MandelaBowAndArrow.MandelaAttachmentHeadIron"] = "MandelaBowAndArrow.MandelaArrowHeadIron",
	["MandelaBowAndArrow.MandelaAttachmentHeadIronTaped"] = "MandelaBowAndArrow.MandelaArrowHeadIronTaped",
	["MandelaBowAndArrow.MandelaAttachmentHeadFlint"] = "MandelaBowAndArrow.MandelaArrowHeadFlint",
	["MandelaBowAndArrow.MandelaAttachmentFletchingsDucttape"] = "MandelaBowAndArrow.MandelaArrowFletchingsDucttape",
	["MandelaBowAndArrow.MandelaAttachmentFletchingsDucttapeFluFlu"] = "MandelaBowAndArrow.MandelaArrowFletchingsDucttapeFluFlu",
	["MandelaBowAndArrow.MandelaAttachmentFletchingsFeather"] = "MandelaBowAndArrow.MandelaArrowFletchingsFeather"
	}

Shared.WeaponWithAttachmentList = {"MandelaBowAndArrow.MandelaArrowBlank", "MandelaBowAndArrow.MandelaBowWoodLongUnstrung"} --We want to see the arrow parts on the arrow, and this unstrung bow...
for bowName, bow in pairs(Shared.Bows) do
	table.insert(Shared.WeaponWithAttachmentList, bowName); --...and on the bows.
end



--This gets the game's version number
Shared.versionNumber = tonumber(tostring(getCore():getGameVersion():getMajor()) .. "." .. tostring(getCore():getGameVersion():getMinor()));